require('ffi').cdef([[
typedef struct GEOSContextHandle_HS *GEOSContextHandle_t;
extern GEOSContextHandle_t
libgeos_init_r();
extern void
libgeos_finish_r(GEOSContextHandle_t handle);
extern const char *
libgeos_last_error(void);
extern const char *
libproj_version(void);
typedef long int ptrdiff_t;
typedef long unsigned int size_t;
typedef int wchar_t;
typedef struct {
  long long __max_align_ll __attribute__((__aligned__(__alignof__(long long))));
  long double __max_align_ld __attribute__((__aligned__(__alignof__(long double))));
} max_align_t;
typedef void (*GEOSMessageHandler)(const char *fmt, ...);
typedef struct GEOSGeom_t GEOSGeometry;
typedef struct GEOSPrepGeom_t GEOSPreparedGeometry;
typedef struct GEOSCoordSeq_t GEOSCoordSequence;
typedef struct GEOSSTRtree_t GEOSSTRtree;
typedef struct GEOSBufParams_t GEOSBufferParams;
typedef GEOSGeometry* GEOSGeom;
typedef GEOSCoordSequence* GEOSCoordSeq;
enum GEOSGeomTypes {
    GEOS_POINT,
    GEOS_LINESTRING,
    GEOS_LINEARRING,
    GEOS_POLYGON,
    GEOS_MULTIPOINT,
    GEOS_MULTILINESTRING,
    GEOS_MULTIPOLYGON,
    GEOS_GEOMETRYCOLLECTION
};
enum GEOSByteOrders {
    GEOS_WKB_XDR = 0,
    GEOS_WKB_NDR = 1
};
typedef struct GEOSContextHandle_HS *GEOSContextHandle_t;
typedef void (*GEOSQueryCallback)(void *item, void *userdata);
extern void initGEOS(GEOSMessageHandler notice_function,
 GEOSMessageHandler error_function);
extern void finishGEOS(void);
typedef void (GEOSInterruptCallback)();
extern GEOSInterruptCallback *GEOS_interruptRegisterCallback(GEOSInterruptCallback* cb);
extern void GEOS_interruptRequest();
extern void GEOS_interruptCancel();
extern GEOSContextHandle_t initGEOS_r(
                                    GEOSMessageHandler notice_function,
                                    GEOSMessageHandler error_function);
extern void finishGEOS_r(GEOSContextHandle_t handle);
extern GEOSMessageHandler GEOSContext_setNoticeHandler_r(GEOSContextHandle_t extHandle,
                                                                  GEOSMessageHandler nf);
extern GEOSMessageHandler GEOSContext_setErrorHandler_r(GEOSContextHandle_t extHandle,
                                                                 GEOSMessageHandler ef);
extern const char *GEOSversion();
extern GEOSGeometry *GEOSGeomFromWKT(const char *wkt);
extern char *GEOSGeomToWKT(const GEOSGeometry* g);
extern GEOSGeometry *GEOSGeomFromWKT_r(GEOSContextHandle_t handle,
                                                const char *wkt);
extern char *GEOSGeomToWKT_r(GEOSContextHandle_t handle,
                                      const GEOSGeometry* g);
extern int GEOS_getWKBOutputDims();
extern int GEOS_setWKBOutputDims(int newDims);
extern int GEOS_getWKBOutputDims_r(GEOSContextHandle_t handle);
extern int GEOS_setWKBOutputDims_r(GEOSContextHandle_t handle,
                                            int newDims);
extern int GEOS_getWKBByteOrder();
extern int GEOS_setWKBByteOrder(int byteOrder);
extern GEOSGeometry *GEOSGeomFromWKB_buf(const unsigned char *wkb, size_t size);
extern unsigned char *GEOSGeomToWKB_buf(const GEOSGeometry* g, size_t *size);
extern GEOSGeometry *GEOSGeomFromHEX_buf(const unsigned char *hex, size_t size);
extern unsigned char *GEOSGeomToHEX_buf(const GEOSGeometry* g, size_t *size);
extern int GEOS_getWKBByteOrder_r(GEOSContextHandle_t handle);
extern int GEOS_setWKBByteOrder_r(GEOSContextHandle_t handle,
                                           int byteOrder);
extern GEOSGeometry *GEOSGeomFromWKB_buf_r(GEOSContextHandle_t handle,
                                                    const unsigned char *wkb,
                                                    size_t size);
extern unsigned char *GEOSGeomToWKB_buf_r(GEOSContextHandle_t handle,
                                                   const GEOSGeometry* g,
                                                   size_t *size);
extern GEOSGeometry *GEOSGeomFromHEX_buf_r(GEOSContextHandle_t handle,
                                                    const unsigned char *hex,
                                                    size_t size);
extern unsigned char *GEOSGeomToHEX_buf_r(GEOSContextHandle_t handle,
                                                   const GEOSGeometry* g,
                                                   size_t *size);
extern GEOSCoordSequence *GEOSCoordSeq_create(unsigned int size, unsigned int dims);
extern GEOSCoordSequence *GEOSCoordSeq_create_r(
                                                GEOSContextHandle_t handle,
                                                unsigned int size,
                                                unsigned int dims);
extern GEOSCoordSequence *GEOSCoordSeq_clone(const GEOSCoordSequence* s);
extern GEOSCoordSequence *GEOSCoordSeq_clone_r(
                                                GEOSContextHandle_t handle,
                                                const GEOSCoordSequence* s);
extern void GEOSCoordSeq_destroy(GEOSCoordSequence* s);
extern void GEOSCoordSeq_destroy_r(GEOSContextHandle_t handle,
                                            GEOSCoordSequence* s);
extern int GEOSCoordSeq_setX(GEOSCoordSequence* s,
 unsigned int idx, double val);
extern int GEOSCoordSeq_setY(GEOSCoordSequence* s,
 unsigned int idx, double val);
extern int GEOSCoordSeq_setZ(GEOSCoordSequence* s,
 unsigned int idx, double val);
extern int GEOSCoordSeq_setOrdinate(GEOSCoordSequence* s,
 unsigned int idx, unsigned int dim, double val);
extern int GEOSCoordSeq_setX_r(GEOSContextHandle_t handle,
                                        GEOSCoordSequence* s, unsigned int idx,
                                        double val);
extern int GEOSCoordSeq_setY_r(GEOSContextHandle_t handle,
                                        GEOSCoordSequence* s, unsigned int idx,
                                        double val);
extern int GEOSCoordSeq_setZ_r(GEOSContextHandle_t handle,
                                        GEOSCoordSequence* s, unsigned int idx,
                                        double val);
extern int GEOSCoordSeq_setOrdinate_r(GEOSContextHandle_t handle,
                                               GEOSCoordSequence* s,
                                               unsigned int idx,
                                               unsigned int dim, double val);
extern int GEOSCoordSeq_getX(const GEOSCoordSequence* s,
 unsigned int idx, double *val);
extern int GEOSCoordSeq_getY(const GEOSCoordSequence* s,
 unsigned int idx, double *val);
extern int GEOSCoordSeq_getZ(const GEOSCoordSequence* s,
 unsigned int idx, double *val);
extern int GEOSCoordSeq_getOrdinate(const GEOSCoordSequence* s,
 unsigned int idx, unsigned int dim, double *val);
extern int GEOSCoordSeq_getX_r(GEOSContextHandle_t handle,
                                        const GEOSCoordSequence* s,
                                        unsigned int idx, double *val);
extern int GEOSCoordSeq_getY_r(GEOSContextHandle_t handle,
                                        const GEOSCoordSequence* s,
                                        unsigned int idx, double *val);
extern int GEOSCoordSeq_getZ_r(GEOSContextHandle_t handle,
                                        const GEOSCoordSequence* s,
                                        unsigned int idx, double *val);
extern int GEOSCoordSeq_getOrdinate_r(GEOSContextHandle_t handle,
                                               const GEOSCoordSequence* s,
                                               unsigned int idx,
                                               unsigned int dim, double *val);
extern int GEOSCoordSeq_getSize(const GEOSCoordSequence* s,
 unsigned int *size);
extern int GEOSCoordSeq_getDimensions(const GEOSCoordSequence* s,
 unsigned int *dims);
extern int GEOSCoordSeq_getSize_r(GEOSContextHandle_t handle,
                                           const GEOSCoordSequence* s,
                                           unsigned int *size);
extern int GEOSCoordSeq_getDimensions_r(GEOSContextHandle_t handle,
                                                 const GEOSCoordSequence* s,
                                                 unsigned int *dims);
extern double GEOSProject(const GEOSGeometry *g,
                                   const GEOSGeometry* p);
extern double GEOSProject_r(GEOSContextHandle_t handle,
                                     const GEOSGeometry *g,
                                     const GEOSGeometry *p);
extern GEOSGeometry *GEOSInterpolate(const GEOSGeometry *g,
                                              double d);
extern GEOSGeometry *GEOSInterpolate_r(GEOSContextHandle_t handle,
                                                const GEOSGeometry *g,
                                                double d);
extern double GEOSProjectNormalized(const GEOSGeometry *g,
                                             const GEOSGeometry* p);
extern double GEOSProjectNormalized_r(GEOSContextHandle_t handle,
                                               const GEOSGeometry *g,
                                               const GEOSGeometry *p);
extern GEOSGeometry *GEOSInterpolateNormalized(const GEOSGeometry *g,
                                                        double d);
extern GEOSGeometry *GEOSInterpolateNormalized_r(
                                                GEOSContextHandle_t handle,
                                                const GEOSGeometry *g,
                                                double d);
extern GEOSGeometry *GEOSBuffer(const GEOSGeometry* g,
 double width, int quadsegs);
extern GEOSGeometry *GEOSBuffer_r(GEOSContextHandle_t handle,
                                           const GEOSGeometry* g,
                                           double width, int quadsegs);
enum GEOSBufCapStyles {
 GEOSBUF_CAP_ROUND=1,
 GEOSBUF_CAP_FLAT=2,
 GEOSBUF_CAP_SQUARE=3
};
enum GEOSBufJoinStyles {
 GEOSBUF_JOIN_ROUND=1,
 GEOSBUF_JOIN_MITRE=2,
 GEOSBUF_JOIN_BEVEL=3
};
extern GEOSBufferParams *GEOSBufferParams_create();
extern GEOSBufferParams *GEOSBufferParams_create_r(
                                              GEOSContextHandle_t handle);
extern void GEOSBufferParams_destroy(GEOSBufferParams* parms);
extern void GEOSBufferParams_destroy_r(
                                              GEOSContextHandle_t handle,
                                              GEOSBufferParams* parms);
extern int GEOSBufferParams_setEndCapStyle(
                                              GEOSBufferParams* p,
                                              int style);
extern int GEOSBufferParams_setEndCapStyle_r(
                                              GEOSContextHandle_t handle,
                                              GEOSBufferParams* p,
                                              int style);
extern int GEOSBufferParams_setJoinStyle(
                                              GEOSBufferParams* p,
                                              int joinStyle);
extern int GEOSBufferParams_setJoinStyle_r(
                                              GEOSContextHandle_t handle,
                                              GEOSBufferParams* p,
                                              int joinStyle);
extern int GEOSBufferParams_setMitreLimit(
                                              GEOSBufferParams* p,
                                              double mitreLimit);
extern int GEOSBufferParams_setMitreLimit_r(
                                              GEOSContextHandle_t handle,
                                              GEOSBufferParams* p,
                                              double mitreLimit);
extern int GEOSBufferParams_setQuadrantSegments(
                                              GEOSBufferParams* p,
                                              int quadSegs);
extern int GEOSBufferParams_setQuadrantSegments_r(
                                              GEOSContextHandle_t handle,
                                              GEOSBufferParams* p,
                                              int quadSegs);
extern int GEOSBufferParams_setSingleSided(
                                              GEOSBufferParams* p,
                                              int singleSided);
extern int GEOSBufferParams_setSingleSided_r(
                                              GEOSContextHandle_t handle,
                                              GEOSBufferParams* p,
                                              int singleSided);
extern GEOSGeometry *GEOSBufferWithParams(
                                              const GEOSGeometry* g,
                                              const GEOSBufferParams* p,
                                              double width);
extern GEOSGeometry *GEOSBufferWithParams_r(
                                              GEOSContextHandle_t handle,
                                              const GEOSGeometry* g,
                                              const GEOSBufferParams* p,
                                              double width);
extern GEOSGeometry *GEOSBufferWithStyle(const GEOSGeometry* g,
 double width, int quadsegs, int endCapStyle, int joinStyle,
 double mitreLimit);
extern GEOSGeometry *GEOSBufferWithStyle_r(GEOSContextHandle_t handle,
 const GEOSGeometry* g, double width, int quadsegs, int endCapStyle,
 int joinStyle, double mitreLimit);
extern GEOSGeometry *GEOSSingleSidedBuffer(const GEOSGeometry* g,
 double width, int quadsegs, int joinStyle, double mitreLimit,
 int leftSide);
extern GEOSGeometry *GEOSSingleSidedBuffer_r(
 GEOSContextHandle_t handle,
 const GEOSGeometry* g, double width, int quadsegs,
 int joinStyle, double mitreLimit, int leftSide);
extern GEOSGeometry *GEOSOffsetCurve(const GEOSGeometry* g,
 double width, int quadsegs, int joinStyle, double mitreLimit);
extern GEOSGeometry *GEOSOffsetCurve_r(GEOSContextHandle_t handle,
 const GEOSGeometry* g, double width, int quadsegs,
 int joinStyle, double mitreLimit);
extern GEOSGeometry *GEOSGeom_createPoint(GEOSCoordSequence* s);
extern GEOSGeometry *GEOSGeom_createEmptyPoint();
extern GEOSGeometry *GEOSGeom_createLinearRing(GEOSCoordSequence* s);
extern GEOSGeometry *GEOSGeom_createLineString(GEOSCoordSequence* s);
extern GEOSGeometry *GEOSGeom_createEmptyLineString();
extern GEOSGeometry *GEOSGeom_createPoint_r(
                                       GEOSContextHandle_t handle,
                                       GEOSCoordSequence* s);
extern GEOSGeometry *GEOSGeom_createEmptyPoint_r(
                                       GEOSContextHandle_t handle);
extern GEOSGeometry *GEOSGeom_createLinearRing_r(
                                       GEOSContextHandle_t handle,
                                       GEOSCoordSequence* s);
extern GEOSGeometry *GEOSGeom_createLineString_r(
                                       GEOSContextHandle_t handle,
                                       GEOSCoordSequence* s);
extern GEOSGeometry *GEOSGeom_createEmptyLineString_r(
                                       GEOSContextHandle_t handle);
extern GEOSGeometry *GEOSGeom_createEmptyPolygon();
extern GEOSGeometry *GEOSGeom_createPolygon(GEOSGeometry* shell,
 GEOSGeometry** holes, unsigned int nholes);
extern GEOSGeometry *GEOSGeom_createCollection(int type,
 GEOSGeometry* *geoms, unsigned int ngeoms);
extern GEOSGeometry *GEOSGeom_createEmptyCollection(int type);
extern GEOSGeometry *GEOSGeom_createEmptyPolygon_r(
                                       GEOSContextHandle_t handle);
extern GEOSGeometry *GEOSGeom_createPolygon_r(
                                       GEOSContextHandle_t handle,
                                       GEOSGeometry* shell,
                                       GEOSGeometry** holes,
                                       unsigned int nholes);
extern GEOSGeometry *GEOSGeom_createCollection_r(
                                       GEOSContextHandle_t handle, int type,
                                       GEOSGeometry* *geoms,
                                       unsigned int ngeoms);
extern GEOSGeometry *GEOSGeom_createEmptyCollection_r(
                                       GEOSContextHandle_t handle, int type);
extern GEOSGeometry *GEOSGeom_clone(const GEOSGeometry* g);
extern GEOSGeometry *GEOSGeom_clone_r(GEOSContextHandle_t handle,
                                               const GEOSGeometry* g);
extern void GEOSGeom_destroy(GEOSGeometry* g);
extern void GEOSGeom_destroy_r(GEOSContextHandle_t handle,
                                        GEOSGeometry* g);
extern GEOSGeometry *GEOSEnvelope(const GEOSGeometry* g);
extern GEOSGeometry *GEOSIntersection(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern GEOSGeometry *GEOSConvexHull(const GEOSGeometry* g);
extern GEOSGeometry *GEOSDifference(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern GEOSGeometry *GEOSSymDifference(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern GEOSGeometry *GEOSBoundary(const GEOSGeometry* g);
extern GEOSGeometry *GEOSUnion(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern GEOSGeometry *GEOSUnaryUnion(const GEOSGeometry* g);
extern GEOSGeometry *GEOSUnionCascaded(const GEOSGeometry* g);
extern GEOSGeometry *GEOSPointOnSurface(const GEOSGeometry* g);
extern GEOSGeometry *GEOSGetCentroid(const GEOSGeometry* g);
extern GEOSGeometry *GEOSNode(const GEOSGeometry* g);
extern GEOSGeometry *GEOSEnvelope_r(GEOSContextHandle_t handle,
                                             const GEOSGeometry* g);
extern GEOSGeometry *GEOSIntersection_r(GEOSContextHandle_t handle,
                                                 const GEOSGeometry* g1,
                                                 const GEOSGeometry* g2);
extern GEOSGeometry *GEOSConvexHull_r(GEOSContextHandle_t handle,
                                               const GEOSGeometry* g);
extern GEOSGeometry *GEOSDifference_r(GEOSContextHandle_t handle,
                                               const GEOSGeometry* g1,
                                               const GEOSGeometry* g2);
extern GEOSGeometry *GEOSSymDifference_r(GEOSContextHandle_t handle,
                                                  const GEOSGeometry* g1,
                                                  const GEOSGeometry* g2);
extern GEOSGeometry *GEOSBoundary_r(GEOSContextHandle_t handle,
                                             const GEOSGeometry* g);
extern GEOSGeometry *GEOSUnion_r(GEOSContextHandle_t handle,
                                          const GEOSGeometry* g1,
                                          const GEOSGeometry* g2);
extern GEOSGeometry *GEOSUnaryUnion_r(GEOSContextHandle_t handle,
                                          const GEOSGeometry* g);
extern GEOSGeometry *GEOSUnionCascaded_r(GEOSContextHandle_t handle,
                                                  const GEOSGeometry* g);
extern GEOSGeometry *GEOSPointOnSurface_r(GEOSContextHandle_t handle,
                                                   const GEOSGeometry* g);
extern GEOSGeometry *GEOSGetCentroid_r(GEOSContextHandle_t handle,
                                                const GEOSGeometry* g);
extern GEOSGeometry *GEOSNode_r(GEOSContextHandle_t handle,
                                         const GEOSGeometry* g);
extern GEOSGeometry *GEOSPolygonize(const GEOSGeometry * const geoms[], unsigned int ngeoms);
extern GEOSGeometry *GEOSPolygonizer_getCutEdges(const GEOSGeometry * const geoms[], unsigned int ngeoms);
extern GEOSGeometry *GEOSPolygonize_full(const GEOSGeometry* input,
 GEOSGeometry** cuts, GEOSGeometry** dangles, GEOSGeometry** invalid);
extern GEOSGeometry *GEOSLineMerge(const GEOSGeometry* g);
extern GEOSGeometry *GEOSSimplify(const GEOSGeometry* g, double tolerance);
extern GEOSGeometry *GEOSTopologyPreserveSimplify(const GEOSGeometry* g,
 double tolerance);
extern GEOSGeometry *GEOSPolygonize_r(GEOSContextHandle_t handle,
                              const GEOSGeometry *const geoms[],
                              unsigned int ngeoms);
extern GEOSGeometry *GEOSPolygonizer_getCutEdges_r(
                              GEOSContextHandle_t handle,
                              const GEOSGeometry * const geoms[],
                              unsigned int ngeoms);
extern GEOSGeometry *GEOSPolygonize_full_r(GEOSContextHandle_t handle,
                              const GEOSGeometry* input, GEOSGeometry** cuts,
                              GEOSGeometry** dangles, GEOSGeometry** invalidRings);
extern GEOSGeometry *GEOSLineMerge_r(GEOSContextHandle_t handle,
                                              const GEOSGeometry* g);
extern GEOSGeometry *GEOSSimplify_r(GEOSContextHandle_t handle,
                                             const GEOSGeometry* g,
                                             double tolerance);
extern GEOSGeometry *GEOSTopologyPreserveSimplify_r(
                              GEOSContextHandle_t handle,
                              const GEOSGeometry* g, double tolerance);
extern GEOSGeometry *GEOSGeom_extractUniquePoints(
                              const GEOSGeometry* g);
extern GEOSGeometry *GEOSGeom_extractUniquePoints_r(
                              GEOSContextHandle_t handle,
                              const GEOSGeometry* g);
extern GEOSGeometry *GEOSSharedPaths(const GEOSGeometry* g1,
  const GEOSGeometry* g2);
extern GEOSGeometry *GEOSSharedPaths_r(GEOSContextHandle_t handle,
  const GEOSGeometry* g1, const GEOSGeometry* g2);
extern GEOSGeometry *GEOSSnap(const GEOSGeometry* g1,
  const GEOSGeometry* g2, double tolerance);
extern GEOSGeometry *GEOSSnap_r(GEOSContextHandle_t handle,
  const GEOSGeometry* g1, const GEOSGeometry* g2, double tolerance);
extern GEOSGeometry * GEOSDelaunayTriangulation(
                                  const GEOSGeometry *g,
                                  double tolerance,
                                  int onlyEdges);
extern GEOSGeometry * GEOSDelaunayTriangulation_r(
                                  GEOSContextHandle_t handle,
                                  const GEOSGeometry *g,
                                  double tolerance,
                                  int onlyEdges);
extern char GEOSDisjoint(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern char GEOSTouches(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern char GEOSIntersects(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern char GEOSCrosses(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern char GEOSWithin(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern char GEOSContains(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern char GEOSOverlaps(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern char GEOSEquals(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern char GEOSEqualsExact(const GEOSGeometry* g1, const GEOSGeometry* g2, double tolerance);
extern char GEOSCovers(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern char GEOSCoveredBy(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern char GEOSDisjoint_r(GEOSContextHandle_t handle,
                                    const GEOSGeometry* g1,
                                    const GEOSGeometry* g2);
extern char GEOSTouches_r(GEOSContextHandle_t handle,
                                   const GEOSGeometry* g1,
                                   const GEOSGeometry* g2);
extern char GEOSIntersects_r(GEOSContextHandle_t handle,
                                      const GEOSGeometry* g1,
                                      const GEOSGeometry* g2);
extern char GEOSCrosses_r(GEOSContextHandle_t handle,
                                   const GEOSGeometry* g1,
                                   const GEOSGeometry* g2);
extern char GEOSWithin_r(GEOSContextHandle_t handle,
                                  const GEOSGeometry* g1,
                                  const GEOSGeometry* g2);
extern char GEOSContains_r(GEOSContextHandle_t handle,
                                    const GEOSGeometry* g1,
                                    const GEOSGeometry* g2);
extern char GEOSOverlaps_r(GEOSContextHandle_t handle,
                                    const GEOSGeometry* g1,
                                    const GEOSGeometry* g2);
extern char GEOSEquals_r(GEOSContextHandle_t handle,
                                  const GEOSGeometry* g1,
                                  const GEOSGeometry* g2);
extern char GEOSEqualsExact_r(GEOSContextHandle_t handle,
                                       const GEOSGeometry* g1,
                                       const GEOSGeometry* g2,
                                       double tolerance);
extern char GEOSCovers_r(GEOSContextHandle_t handle,
                                  const GEOSGeometry* g1,
                                  const GEOSGeometry* g2);
extern char GEOSCoveredBy_r(GEOSContextHandle_t handle,
                                  const GEOSGeometry* g1,
                                  const GEOSGeometry* g2);
extern const GEOSPreparedGeometry *GEOSPrepare(const GEOSGeometry* g);
extern void GEOSPreparedGeom_destroy(const GEOSPreparedGeometry* g);
extern char GEOSPreparedContains(const GEOSPreparedGeometry* pg1, const GEOSGeometry* g2);
extern char GEOSPreparedContainsProperly(const GEOSPreparedGeometry* pg1, const GEOSGeometry* g2);
extern char GEOSPreparedCoveredBy(const GEOSPreparedGeometry* pg1, const GEOSGeometry* g2);
extern char GEOSPreparedCovers(const GEOSPreparedGeometry* pg1, const GEOSGeometry* g2);
extern char GEOSPreparedCrosses(const GEOSPreparedGeometry* pg1, const GEOSGeometry* g2);
extern char GEOSPreparedDisjoint(const GEOSPreparedGeometry* pg1, const GEOSGeometry* g2);
extern char GEOSPreparedIntersects(const GEOSPreparedGeometry* pg1, const GEOSGeometry* g2);
extern char GEOSPreparedOverlaps(const GEOSPreparedGeometry* pg1, const GEOSGeometry* g2);
extern char GEOSPreparedTouches(const GEOSPreparedGeometry* pg1, const GEOSGeometry* g2);
extern char GEOSPreparedWithin(const GEOSPreparedGeometry* pg1, const GEOSGeometry* g2);
extern const GEOSPreparedGeometry *GEOSPrepare_r(
                                            GEOSContextHandle_t handle,
                                            const GEOSGeometry* g);
extern void GEOSPreparedGeom_destroy_r(GEOSContextHandle_t handle,
                                                const GEOSPreparedGeometry* g);
extern char GEOSPreparedContains_r(GEOSContextHandle_t handle,
                                            const GEOSPreparedGeometry* pg1,
                                            const GEOSGeometry* g2);
extern char GEOSPreparedContainsProperly_r(GEOSContextHandle_t handle,
                                         const GEOSPreparedGeometry* pg1,
                                         const GEOSGeometry* g2);
extern char GEOSPreparedCoveredBy_r(GEOSContextHandle_t handle,
                                          const GEOSPreparedGeometry* pg1,
                                          const GEOSGeometry* g2);
extern char GEOSPreparedCovers_r(GEOSContextHandle_t handle,
                                          const GEOSPreparedGeometry* pg1,
                                          const GEOSGeometry* g2);
extern char GEOSPreparedCrosses_r(GEOSContextHandle_t handle,
                                          const GEOSPreparedGeometry* pg1,
                                          const GEOSGeometry* g2);
extern char GEOSPreparedDisjoint_r(GEOSContextHandle_t handle,
                                          const GEOSPreparedGeometry* pg1,
                                          const GEOSGeometry* g2);
extern char GEOSPreparedIntersects_r(GEOSContextHandle_t handle,
                                              const GEOSPreparedGeometry* pg1,
                                              const GEOSGeometry* g2);
extern char GEOSPreparedOverlaps_r(GEOSContextHandle_t handle,
                                          const GEOSPreparedGeometry* pg1,
                                          const GEOSGeometry* g2);
extern char GEOSPreparedTouches_r(GEOSContextHandle_t handle,
                                          const GEOSPreparedGeometry* pg1,
                                          const GEOSGeometry* g2);
extern char GEOSPreparedWithin_r(GEOSContextHandle_t handle,
                                          const GEOSPreparedGeometry* pg1,
                                          const GEOSGeometry* g2);
extern GEOSSTRtree *GEOSSTRtree_create(size_t nodeCapacity);
extern void GEOSSTRtree_insert(GEOSSTRtree *tree,
                                        const GEOSGeometry *g,
                                        void *item);
extern void GEOSSTRtree_query(GEOSSTRtree *tree,
                                       const GEOSGeometry *g,
                                       GEOSQueryCallback callback,
                                       void *userdata);
extern void GEOSSTRtree_iterate(GEOSSTRtree *tree,
                                       GEOSQueryCallback callback,
                                       void *userdata);
extern char GEOSSTRtree_remove(GEOSSTRtree *tree,
                                        const GEOSGeometry *g,
                                        void *item);
extern void GEOSSTRtree_destroy(GEOSSTRtree *tree);
extern GEOSSTRtree *GEOSSTRtree_create_r(
                                    GEOSContextHandle_t handle,
                                    size_t nodeCapacity);
extern void GEOSSTRtree_insert_r(GEOSContextHandle_t handle,
                                          GEOSSTRtree *tree,
                                          const GEOSGeometry *g,
                                          void *item);
extern void GEOSSTRtree_query_r(GEOSContextHandle_t handle,
                                         GEOSSTRtree *tree,
                                         const GEOSGeometry *g,
                                         GEOSQueryCallback callback,
                                         void *userdata);
extern void GEOSSTRtree_iterate_r(GEOSContextHandle_t handle,
                                       GEOSSTRtree *tree,
                                       GEOSQueryCallback callback,
                                       void *userdata);
extern char GEOSSTRtree_remove_r(GEOSContextHandle_t handle,
                                          GEOSSTRtree *tree,
                                          const GEOSGeometry *g,
                                          void *item);
extern void GEOSSTRtree_destroy_r(GEOSContextHandle_t handle,
                                           GEOSSTRtree *tree);
extern char GEOSisEmpty(const GEOSGeometry* g);
extern char GEOSisSimple(const GEOSGeometry* g);
extern char GEOSisRing(const GEOSGeometry* g);
extern char GEOSHasZ(const GEOSGeometry* g);
extern char GEOSisClosed(const GEOSGeometry *g);
extern char GEOSisEmpty_r(GEOSContextHandle_t handle,
                                   const GEOSGeometry* g);
extern char GEOSisSimple_r(GEOSContextHandle_t handle,
                                    const GEOSGeometry* g);
extern char GEOSisRing_r(GEOSContextHandle_t handle,
                                  const GEOSGeometry* g);
extern char GEOSHasZ_r(GEOSContextHandle_t handle,
                                const GEOSGeometry* g);
extern char GEOSisClosed_r(GEOSContextHandle_t handle,
                                const GEOSGeometry *g);
enum GEOSRelateBoundaryNodeRules {
 GEOSRELATE_BNR_MOD2=1,
 GEOSRELATE_BNR_OGC=1,
 GEOSRELATE_BNR_ENDPOINT=2,
 GEOSRELATE_BNR_MULTIVALENT_ENDPOINT=3,
 GEOSRELATE_BNR_MONOVALENT_ENDPOINT=4
};
extern char GEOSRelatePattern(const GEOSGeometry* g1, const GEOSGeometry* g2, const char *pat);
extern char GEOSRelatePattern_r(GEOSContextHandle_t handle,
                                         const GEOSGeometry* g1,
                                         const GEOSGeometry* g2,
                                         const char *pat);
extern char *GEOSRelate(const GEOSGeometry* g1, const GEOSGeometry* g2);
extern char *GEOSRelate_r(GEOSContextHandle_t handle,
                                   const GEOSGeometry* g1,
                                   const GEOSGeometry* g2);
extern char GEOSRelatePatternMatch(const char *mat, const char *pat);
extern char GEOSRelatePatternMatch_r(GEOSContextHandle_t handle,
                                         const char *mat,
                                         const char *pat);
extern char *GEOSRelateBoundaryNodeRule(const GEOSGeometry* g1,
                                                 const GEOSGeometry* g2,
                                                 int bnr);
extern char *GEOSRelateBoundaryNodeRule_r(GEOSContextHandle_t handle,
                                                   const GEOSGeometry* g1,
                                                   const GEOSGeometry* g2,
                                                   int bnr);
enum GEOSValidFlags {
 GEOSVALID_ALLOW_SELFTOUCHING_RING_FORMING_HOLE=1
};
extern char GEOSisValid(const GEOSGeometry* g);
extern char GEOSisValid_r(GEOSContextHandle_t handle,
                                   const GEOSGeometry* g);
extern char *GEOSisValidReason(const GEOSGeometry *g);
extern char *GEOSisValidReason_r(GEOSContextHandle_t handle,
                                         const GEOSGeometry* g);
extern char GEOSisValidDetail(const GEOSGeometry* g,
                                       int flags,
                                       char** reason, GEOSGeometry** location);
extern char GEOSisValidDetail_r(GEOSContextHandle_t handle,
                                         const GEOSGeometry* g,
                                         int flags,
                                         char** reason,
                                         GEOSGeometry** location);
extern char *GEOSGeomType(const GEOSGeometry* g);
extern char *GEOSGeomType_r(GEOSContextHandle_t handle,
                                     const GEOSGeometry* g);
extern int GEOSGeomTypeId(const GEOSGeometry* g);
extern int GEOSGeomTypeId_r(GEOSContextHandle_t handle,
                                     const GEOSGeometry* g);
extern int GEOSGetSRID(const GEOSGeometry* g);
extern int GEOSGetSRID_r(GEOSContextHandle_t handle,
                                  const GEOSGeometry* g);
extern void GEOSSetSRID(GEOSGeometry* g, int SRID);
extern void GEOSSetSRID_r(GEOSContextHandle_t handle,
                                   GEOSGeometry* g, int SRID);
extern int GEOSGetNumGeometries(const GEOSGeometry* g);
extern int GEOSGetNumGeometries_r(GEOSContextHandle_t handle,
                                           const GEOSGeometry* g);
extern const GEOSGeometry *GEOSGetGeometryN(const GEOSGeometry* g, int n);
extern const GEOSGeometry *GEOSGetGeometryN_r(
                                    GEOSContextHandle_t handle,
                                    const GEOSGeometry* g, int n);
extern int GEOSNormalize(GEOSGeometry* g);
extern int GEOSNormalize_r(GEOSContextHandle_t handle,
                                    GEOSGeometry* g);
extern int GEOSGetNumInteriorRings(const GEOSGeometry* g);
extern int GEOSGetNumInteriorRings_r(GEOSContextHandle_t handle,
                                              const GEOSGeometry* g);
extern int GEOSGeomGetNumPoints(const GEOSGeometry* g);
extern int GEOSGeomGetNumPoints_r(GEOSContextHandle_t handle,
                                       const GEOSGeometry* g);
extern int GEOSGeomGetX(const GEOSGeometry *g, double *x);
extern int GEOSGeomGetY(const GEOSGeometry *g, double *y);
extern int GEOSGeomGetX_r(GEOSContextHandle_t handle, const GEOSGeometry *g, double *x);
extern int GEOSGeomGetY_r(GEOSContextHandle_t handle, const GEOSGeometry *g, double *y);
extern const GEOSGeometry *GEOSGetInteriorRingN(const GEOSGeometry* g, int n);
extern const GEOSGeometry *GEOSGetInteriorRingN_r(
                                    GEOSContextHandle_t handle,
                                    const GEOSGeometry* g, int n);
extern const GEOSGeometry *GEOSGetExteriorRing(const GEOSGeometry* g);
extern const GEOSGeometry *GEOSGetExteriorRing_r(
                                    GEOSContextHandle_t handle,
                                    const GEOSGeometry* g);
extern int GEOSGetNumCoordinates(const GEOSGeometry* g);
extern int GEOSGetNumCoordinates_r(GEOSContextHandle_t handle,
                                            const GEOSGeometry* g);
extern const GEOSCoordSequence *GEOSGeom_getCoordSeq(const GEOSGeometry* g);
extern const GEOSCoordSequence *GEOSGeom_getCoordSeq_r(
                                         GEOSContextHandle_t handle,
                                         const GEOSGeometry* g);
extern int GEOSGeom_getDimensions(const GEOSGeometry* g);
extern int GEOSGeom_getDimensions_r(GEOSContextHandle_t handle,
                                             const GEOSGeometry* g);
extern int GEOSGeom_getCoordinateDimension(const GEOSGeometry* g);
extern int GEOSGeom_getCoordinateDimension_r(GEOSContextHandle_t handle,
                                                      const GEOSGeometry* g);
extern GEOSGeometry *GEOSGeomGetPointN(const GEOSGeometry *g, int n);
extern GEOSGeometry *GEOSGeomGetStartPoint(const GEOSGeometry *g);
extern GEOSGeometry *GEOSGeomGetEndPoint(const GEOSGeometry *g);
extern GEOSGeometry *GEOSGeomGetPointN_r(GEOSContextHandle_t handle, const GEOSGeometry *g, int n);
extern GEOSGeometry *GEOSGeomGetStartPoint_r(GEOSContextHandle_t handle, const GEOSGeometry *g);
extern GEOSGeometry *GEOSGeomGetEndPoint_r(GEOSContextHandle_t handle, const GEOSGeometry *g);
extern int GEOSArea(const GEOSGeometry* g, double *area);
extern int GEOSLength(const GEOSGeometry* g, double *length);
extern int GEOSDistance(const GEOSGeometry* g1, const GEOSGeometry* g2,
 double *dist);
extern int GEOSHausdorffDistance(const GEOSGeometry *g1,
        const GEOSGeometry *g2, double *dist);
extern int GEOSHausdorffDistanceDensify(const GEOSGeometry *g1,
        const GEOSGeometry *g2, double densifyFrac, double *dist);
extern int GEOSGeomGetLength(const GEOSGeometry *g, double *length);
extern int GEOSArea_r(GEOSContextHandle_t handle,
                               const GEOSGeometry* g, double *area);
extern int GEOSLength_r(GEOSContextHandle_t handle,
                                 const GEOSGeometry* g, double *length);
extern int GEOSDistance_r(GEOSContextHandle_t handle,
                                   const GEOSGeometry* g1,
                                   const GEOSGeometry* g2, double *dist);
extern int GEOSHausdorffDistance_r(GEOSContextHandle_t handle,
                                   const GEOSGeometry *g1,
                                   const GEOSGeometry *g2,
                                   double *dist);
extern int GEOSHausdorffDistanceDensify_r(GEOSContextHandle_t handle,
                                   const GEOSGeometry *g1,
                                   const GEOSGeometry *g2,
                                   double densifyFrac, double *dist);
extern int GEOSGeomGetLength_r(GEOSContextHandle_t handle,
                                   const GEOSGeometry *g, double *length);
extern GEOSCoordSequence *GEOSNearestPoints(
  const GEOSGeometry* g1, const GEOSGeometry* g2);
extern GEOSCoordSequence *GEOSNearestPoints_r(
  GEOSContextHandle_t handle, const GEOSGeometry* g1, const GEOSGeometry* g2);
extern int GEOSOrientationIndex(double Ax, double Ay, double Bx, double By,
 double Px, double Py);
extern int GEOSOrientationIndex_r(GEOSContextHandle_t handle,
 double Ax, double Ay, double Bx, double By, double Px, double Py);
typedef struct GEOSWKTReader_t GEOSWKTReader;
typedef struct GEOSWKTWriter_t GEOSWKTWriter;
typedef struct GEOSWKBReader_t GEOSWKBReader;
typedef struct GEOSWKBWriter_t GEOSWKBWriter;
extern GEOSWKTReader *GEOSWKTReader_create();
extern void GEOSWKTReader_destroy(GEOSWKTReader* reader);
extern GEOSGeometry *GEOSWKTReader_read(GEOSWKTReader* reader, const char *wkt);
extern GEOSWKTReader *GEOSWKTReader_create_r(
                                             GEOSContextHandle_t handle);
extern void GEOSWKTReader_destroy_r(GEOSContextHandle_t handle,
                                             GEOSWKTReader* reader);
extern GEOSGeometry *GEOSWKTReader_read_r(GEOSContextHandle_t handle,
                                                   GEOSWKTReader* reader,
                                                   const char *wkt);
extern GEOSWKTWriter *GEOSWKTWriter_create();
extern void GEOSWKTWriter_destroy(GEOSWKTWriter* writer);
extern char *GEOSWKTWriter_write(GEOSWKTWriter* writer, const GEOSGeometry* g);
extern void GEOSWKTWriter_setTrim(GEOSWKTWriter *writer, char trim);
extern void GEOSWKTWriter_setRoundingPrecision(GEOSWKTWriter *writer, int precision);
extern void GEOSWKTWriter_setOutputDimension(GEOSWKTWriter *writer, int dim);
extern int GEOSWKTWriter_getOutputDimension(GEOSWKTWriter *writer);
extern void GEOSWKTWriter_setOld3D(GEOSWKTWriter *writer, int useOld3D);
extern GEOSWKTWriter *GEOSWKTWriter_create_r(
                                             GEOSContextHandle_t handle);
extern void GEOSWKTWriter_destroy_r(GEOSContextHandle_t handle,
                                             GEOSWKTWriter* writer);
extern char *GEOSWKTWriter_write_r(GEOSContextHandle_t handle,
                                            GEOSWKTWriter* writer,
                                            const GEOSGeometry* g);
extern void GEOSWKTWriter_setTrim_r(GEOSContextHandle_t handle,
                                            GEOSWKTWriter *writer,
                                            char trim);
extern void GEOSWKTWriter_setRoundingPrecision_r(GEOSContextHandle_t handle,
                                            GEOSWKTWriter *writer,
                                            int precision);
extern void GEOSWKTWriter_setOutputDimension_r(GEOSContextHandle_t handle,
                                                        GEOSWKTWriter *writer,
                                                        int dim);
extern int GEOSWKTWriter_getOutputDimension_r(GEOSContextHandle_t handle,
                                                        GEOSWKTWriter *writer);
extern void GEOSWKTWriter_setOld3D_r(GEOSContextHandle_t handle,
                                              GEOSWKTWriter *writer,
                                              int useOld3D);
extern GEOSWKBReader *GEOSWKBReader_create();
extern void GEOSWKBReader_destroy(GEOSWKBReader* reader);
extern GEOSGeometry *GEOSWKBReader_read(GEOSWKBReader* reader, const unsigned char *wkb, size_t size);
extern GEOSGeometry *GEOSWKBReader_readHEX(GEOSWKBReader* reader, const unsigned char *hex, size_t size);
extern GEOSWKBReader *GEOSWKBReader_create_r(
                                             GEOSContextHandle_t handle);
extern void GEOSWKBReader_destroy_r(GEOSContextHandle_t handle,
                                             GEOSWKBReader* reader);
extern GEOSGeometry *GEOSWKBReader_read_r(GEOSContextHandle_t handle,
                                                   GEOSWKBReader* reader,
                                                   const unsigned char *wkb,
                                                   size_t size);
extern GEOSGeometry *GEOSWKBReader_readHEX_r(
                                            GEOSContextHandle_t handle,
                                            GEOSWKBReader* reader,
                                            const unsigned char *hex,
                                            size_t size);
extern GEOSWKBWriter *GEOSWKBWriter_create();
extern void GEOSWKBWriter_destroy(GEOSWKBWriter* writer);
extern GEOSWKBWriter *GEOSWKBWriter_create_r(
                                             GEOSContextHandle_t handle);
extern void GEOSWKBWriter_destroy_r(GEOSContextHandle_t handle,
                                             GEOSWKBWriter* writer);
extern unsigned char *GEOSWKBWriter_write(GEOSWKBWriter* writer, const GEOSGeometry* g, size_t *size);
extern unsigned char *GEOSWKBWriter_writeHEX(GEOSWKBWriter* writer, const GEOSGeometry* g, size_t *size);
extern unsigned char *GEOSWKBWriter_write_r(
                                             GEOSContextHandle_t handle,
                                             GEOSWKBWriter* writer,
                                             const GEOSGeometry* g,
                                             size_t *size);
extern unsigned char *GEOSWKBWriter_writeHEX_r(
                                             GEOSContextHandle_t handle,
                                             GEOSWKBWriter* writer,
                                             const GEOSGeometry* g,
                                             size_t *size);
extern int GEOSWKBWriter_getOutputDimension(const GEOSWKBWriter* writer);
extern void GEOSWKBWriter_setOutputDimension(GEOSWKBWriter* writer, int newDimension);
extern int GEOSWKBWriter_getOutputDimension_r(
                                  GEOSContextHandle_t handle,
                                  const GEOSWKBWriter* writer);
extern void GEOSWKBWriter_setOutputDimension_r(
                                   GEOSContextHandle_t handle,
                                   GEOSWKBWriter* writer, int newDimension);
extern int GEOSWKBWriter_getByteOrder(const GEOSWKBWriter* writer);
extern void GEOSWKBWriter_setByteOrder(GEOSWKBWriter* writer, int byteOrder);
extern int GEOSWKBWriter_getByteOrder_r(GEOSContextHandle_t handle,
                                                 const GEOSWKBWriter* writer);
extern void GEOSWKBWriter_setByteOrder_r(GEOSContextHandle_t handle,
                                                  GEOSWKBWriter* writer,
                                                  int byteOrder);
extern char GEOSWKBWriter_getIncludeSRID(const GEOSWKBWriter* writer);
extern void GEOSWKBWriter_setIncludeSRID(GEOSWKBWriter* writer, const char writeSRID);
extern char GEOSWKBWriter_getIncludeSRID_r(GEOSContextHandle_t handle,
                                   const GEOSWKBWriter* writer);
extern void GEOSWKBWriter_setIncludeSRID_r(GEOSContextHandle_t handle,
                                   GEOSWKBWriter* writer, const char writeSRID);
extern void GEOSFree(void *buffer);
extern void GEOSFree_r(GEOSContextHandle_t handle, void *buffer);
]])
